﻿Imports System.IO
Imports System.Drawing.Imaging

Public Class Form1
    ' Split the file.
    Private Sub btnGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGo.Click
        ' Get the inputs.
        Dim wid As Integer = Integer.Parse(txtWidth.Text)
        Dim hgt As Integer = Integer.Parse(txtHeight.Text)
        Dim bm As Bitmap = LoadUnlocked(txtFile.Text)

        ' Start splitting the Bitmap.
        Dim piece_name As String = Path.GetFileNameWithoutExtension(txtFile.Text)
        Dim piece As New Bitmap(wid, hgt)
        Dim dest_rect As New Rectangle(0, 0, wid, hgt)
        Using gr As Graphics = Graphics.FromImage(piece)
            Dim num_rows As Integer = CInt(bm.Height / hgt)
            Dim num_cols As Integer = CInt(bm.Width / wid)
            Dim source_rect As New Rectangle(0, 0, wid, hgt)
            For row As Integer = 0 To num_rows - 1
                source_rect.X = 0
                For col = 0 To num_cols - 1
                    ' Copy the piece of the image.
                    gr.DrawImage(bm, dest_rect, source_rect, GraphicsUnit.Pixel)

                    ' Save the piece.
                    Dim filename As String = piece_name & _
                        row.ToString("00") & _
                        col.ToString("00") & ".bmp"
                    piece.Save(filename, ImageFormat.Bmp)

                    ' Move to the next column.
                    source_rect.X += wid
                Next col
                source_rect.Y += hgt
            Next row
            MessageBox.Show("Created " & num_rows * num_cols & " files", _
                "Done", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Using
    End Sub

    ' Load a Bitmap without locking its file.
    Private Function LoadUnlocked(ByVal file_name As String) As Bitmap
        Using bm As New Bitmap(file_name)
            Dim copied_bm As New Bitmap(bm.Width, bm.Height)
            Using gr As Graphics = Graphics.FromImage(copied_bm)
                gr.DrawImage(bm, 0, 0)
            End Using
            Return copied_bm
        End Using
    End Function
End Class
